// keim08core.v

// Generated using ACDS version 18.1 625

`timescale 1 ps / 1 ps
module keim08core (
		input  wire        altpll_areset_export,               //               altpll_areset.export
		output wire        altpll_c1_clk,                      //                   altpll_c1.clk
		output wire        altpll_locked_export,               //               altpll_locked.export
		input  wire        clk_clk,                            //                         clk.clk
		output wire [0:0]  emif_flash_tcm_reset_n_out,         //                        emif.flash_tcm_reset_n_out
		output wire [0:0]  emif_sdram_sdram_cke,               //                            .sdram_sdram_cke
		output wire [0:0]  emif_sdram_sdram_cas_n,             //                            .sdram_sdram_cas_n
		inout  wire [15:0] emif_dq,                            //                            .dq
		output wire [0:0]  emif_sdram_sdram_we_n,              //                            .sdram_sdram_we_n
		output wire [0:0]  emif_sdram_sdram_cs_n,              //                            .sdram_sdram_cs_n
		output wire [0:0]  emif_flash_tcm_chipselect_n_out,    //                            .flash_tcm_chipselect_n_out
		output wire [21:0] emif_addr,                          //                            .addr
		output wire [1:0]  emif_sdram_sdram_ba,                //                            .sdram_sdram_ba
		output wire [1:0]  emif_sdram_sdram_dqm,               //                            .sdram_sdram_dqm
		output wire [0:0]  emif_sdram_sdram_ras_n,             //                            .sdram_sdram_ras_n
		output wire [0:0]  emif_flash_tcm_write_n_out,         //                            .flash_tcm_write_n_out
		output wire [0:0]  emif_flash_tcm_read_n_out,          //                            .flash_tcm_read_n_out
		output wire [1:0]  pio_led_external_connection_export, // pio_led_external_connection.export
		input  wire        reset_reset_n,                      //                       reset.reset_n
		input  wire        uart_0_rxd,                         //                      uart_0.rxd
		output wire        uart_0_txd                          //                            .txd
	);

	wire         altpll_c0_clk;                                                    // altpll:c0 -> [flash:clk_clk, irq_mapper:clk, jtag_uart_0:clk, mm_interconnect_0:altpll_c0_clk, nios2_gen2:clk, onchip_flash:clock, onchip_memory:clk, pio_led:clk, reset_controller:clk, rst_controller_001:clk, sdram:clk, sysid_qsys:clock, timer_100ms:clk, tristate_conduit_bridge_0:clk, tristate_conduit_pin_sharer_0:clk_clk, uart_0:clk]
	wire         nios2_gen2_debug_reset_request_reset;                             // nios2_gen2:debug_reset_request -> reset_controller:reset_in1
	wire         tristate_conduit_pin_sharer_0_tcm_dq_outen;                       // tristate_conduit_pin_sharer_0:dq_outen -> tristate_conduit_bridge_0:tcs_dq_outen
	wire         tristate_conduit_pin_sharer_0_tcm_request;                        // tristate_conduit_pin_sharer_0:request -> tristate_conduit_bridge_0:request
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cs_n_out;           // tristate_conduit_pin_sharer_0:sdram_sdram_cs_n -> tristate_conduit_bridge_0:tcs_sdram_sdram_cs_n
	wire  [15:0] tristate_conduit_pin_sharer_0_tcm_dq_in;                          // tristate_conduit_bridge_0:tcs_dq_in -> tristate_conduit_pin_sharer_0:dq_in
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_sdram_sdram_we_n_out;           // tristate_conduit_pin_sharer_0:sdram_sdram_we_n -> tristate_conduit_bridge_0:tcs_sdram_sdram_we_n
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_flash_tcm_read_n_out_out;       // tristate_conduit_pin_sharer_0:flash_tcm_read_n_out -> tristate_conduit_bridge_0:tcs_flash_tcm_read_n_out
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_sdram_sdram_ras_n_out;          // tristate_conduit_pin_sharer_0:sdram_sdram_ras_n -> tristate_conduit_bridge_0:tcs_sdram_sdram_ras_n
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cke_out;            // tristate_conduit_pin_sharer_0:sdram_sdram_cke -> tristate_conduit_bridge_0:tcs_sdram_sdram_cke
	wire   [1:0] tristate_conduit_pin_sharer_0_tcm_sdram_sdram_ba_out;             // tristate_conduit_pin_sharer_0:sdram_sdram_ba -> tristate_conduit_bridge_0:tcs_sdram_sdram_ba
	wire   [1:0] tristate_conduit_pin_sharer_0_tcm_sdram_sdram_dqm_out;            // tristate_conduit_pin_sharer_0:sdram_sdram_dqm -> tristate_conduit_bridge_0:tcs_sdram_sdram_dqm
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_flash_tcm_chipselect_n_out_out; // tristate_conduit_pin_sharer_0:flash_tcm_chipselect_n_out -> tristate_conduit_bridge_0:tcs_flash_tcm_chipselect_n_out
	wire  [15:0] tristate_conduit_pin_sharer_0_tcm_dq_out;                         // tristate_conduit_pin_sharer_0:dq -> tristate_conduit_bridge_0:tcs_dq
	wire  [21:0] tristate_conduit_pin_sharer_0_tcm_addr_out;                       // tristate_conduit_pin_sharer_0:addr -> tristate_conduit_bridge_0:tcs_addr
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_flash_tcm_reset_n_out_out;      // tristate_conduit_pin_sharer_0:flash_tcm_reset_n_out -> tristate_conduit_bridge_0:tcs_flash_tcm_reset_n_out
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_flash_tcm_write_n_out_out;      // tristate_conduit_pin_sharer_0:flash_tcm_write_n_out -> tristate_conduit_bridge_0:tcs_flash_tcm_write_n_out
	wire         tristate_conduit_pin_sharer_0_tcm_grant;                          // tristate_conduit_bridge_0:grant -> tristate_conduit_pin_sharer_0:grant
	wire   [0:0] tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cas_n_out;          // tristate_conduit_pin_sharer_0:sdram_sdram_cas_n -> tristate_conduit_bridge_0:tcs_sdram_sdram_cas_n
	wire         sdram_tcm_dq_outen;                                               // sdram:sdram_dq_oe -> tristate_conduit_pin_sharer_0:tcs0_dq_outen
	wire   [1:0] sdram_tcm_dqm_out;                                                // sdram:sdram_dqm -> tristate_conduit_pin_sharer_0:tcs0_dqm_out
	wire         sdram_tcm_request;                                                // sdram:tcm_request -> tristate_conduit_pin_sharer_0:tcs0_request
	wire  [15:0] sdram_tcm_dq_in;                                                  // tristate_conduit_pin_sharer_0:tcs0_dq_in -> sdram:sdram_dq_in
	wire         sdram_tcm_cs_out;                                                 // sdram:sdram_cs_n -> tristate_conduit_pin_sharer_0:tcs0_cs_out
	wire   [1:0] sdram_tcm_ba_out;                                                 // sdram:sdram_ba -> tristate_conduit_pin_sharer_0:tcs0_ba_out
	wire         sdram_tcm_we_out;                                                 // sdram:sdram_we_n -> tristate_conduit_pin_sharer_0:tcs0_we_out
	wire         sdram_tcm_cas_out;                                                // sdram:sdram_cas_n -> tristate_conduit_pin_sharer_0:tcs0_cas_out
	wire  [15:0] sdram_tcm_dq_out;                                                 // sdram:sdram_dq_out -> tristate_conduit_pin_sharer_0:tcs0_dq_out
	wire         sdram_tcm_cke_out;                                                // sdram:sdram_cke -> tristate_conduit_pin_sharer_0:tcs0_cke_out
	wire  [11:0] sdram_tcm_addr_out;                                               // sdram:sdram_addr -> tristate_conduit_pin_sharer_0:tcs0_addr_out
	wire         sdram_tcm_grant;                                                  // tristate_conduit_pin_sharer_0:tcs0_grant -> sdram:tcm_grant
	wire         sdram_tcm_ras_out;                                                // sdram:sdram_ras_n -> tristate_conduit_pin_sharer_0:tcs0_ras_out
	wire         flash_tcm_data_outen;                                             // flash:tcm_data_outen -> tristate_conduit_pin_sharer_0:tcs1_data_outen
	wire         flash_tcm_request;                                                // flash:tcm_request -> tristate_conduit_pin_sharer_0:tcs1_request
	wire         flash_tcm_write_n_out;                                            // flash:tcm_write_n_out -> tristate_conduit_pin_sharer_0:tcs1_write_n_out
	wire         flash_tcm_read_n_out;                                             // flash:tcm_read_n_out -> tristate_conduit_pin_sharer_0:tcs1_read_n_out
	wire         flash_tcm_grant;                                                  // tristate_conduit_pin_sharer_0:tcs1_grant -> flash:tcm_grant
	wire         flash_tcm_reset_n_out;                                            // flash:tcm_reset_n_out -> tristate_conduit_pin_sharer_0:tcs1_reset_n_out
	wire         flash_tcm_chipselect_n_out;                                       // flash:tcm_chipselect_n_out -> tristate_conduit_pin_sharer_0:tcs1_chipselect_n_out
	wire  [21:0] flash_tcm_address_out;                                            // flash:tcm_address_out -> tristate_conduit_pin_sharer_0:tcs1_address_out
	wire  [15:0] flash_tcm_data_out;                                               // flash:tcm_data_out -> tristate_conduit_pin_sharer_0:tcs1_data_out
	wire  [15:0] flash_tcm_data_in;                                                // tristate_conduit_pin_sharer_0:tcs1_data_in -> flash:tcm_data_in
	wire  [31:0] nios2_gen2_data_master_readdata;                                  // mm_interconnect_0:nios2_gen2_data_master_readdata -> nios2_gen2:d_readdata
	wire         nios2_gen2_data_master_waitrequest;                               // mm_interconnect_0:nios2_gen2_data_master_waitrequest -> nios2_gen2:d_waitrequest
	wire         nios2_gen2_data_master_debugaccess;                               // nios2_gen2:debug_mem_slave_debugaccess_to_roms -> mm_interconnect_0:nios2_gen2_data_master_debugaccess
	wire  [25:0] nios2_gen2_data_master_address;                                   // nios2_gen2:d_address -> mm_interconnect_0:nios2_gen2_data_master_address
	wire   [3:0] nios2_gen2_data_master_byteenable;                                // nios2_gen2:d_byteenable -> mm_interconnect_0:nios2_gen2_data_master_byteenable
	wire         nios2_gen2_data_master_read;                                      // nios2_gen2:d_read -> mm_interconnect_0:nios2_gen2_data_master_read
	wire         nios2_gen2_data_master_readdatavalid;                             // mm_interconnect_0:nios2_gen2_data_master_readdatavalid -> nios2_gen2:d_readdatavalid
	wire         nios2_gen2_data_master_write;                                     // nios2_gen2:d_write -> mm_interconnect_0:nios2_gen2_data_master_write
	wire  [31:0] nios2_gen2_data_master_writedata;                                 // nios2_gen2:d_writedata -> mm_interconnect_0:nios2_gen2_data_master_writedata
	wire  [31:0] nios2_gen2_instruction_master_readdata;                           // mm_interconnect_0:nios2_gen2_instruction_master_readdata -> nios2_gen2:i_readdata
	wire         nios2_gen2_instruction_master_waitrequest;                        // mm_interconnect_0:nios2_gen2_instruction_master_waitrequest -> nios2_gen2:i_waitrequest
	wire  [25:0] nios2_gen2_instruction_master_address;                            // nios2_gen2:i_address -> mm_interconnect_0:nios2_gen2_instruction_master_address
	wire         nios2_gen2_instruction_master_read;                               // nios2_gen2:i_read -> mm_interconnect_0:nios2_gen2_instruction_master_read
	wire         nios2_gen2_instruction_master_readdatavalid;                      // mm_interconnect_0:nios2_gen2_instruction_master_readdatavalid -> nios2_gen2:i_readdatavalid
	wire         mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_chipselect;       // mm_interconnect_0:jtag_uart_0_avalon_jtag_slave_chipselect -> jtag_uart_0:av_chipselect
	wire  [31:0] mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_readdata;         // jtag_uart_0:av_readdata -> mm_interconnect_0:jtag_uart_0_avalon_jtag_slave_readdata
	wire         mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_waitrequest;      // jtag_uart_0:av_waitrequest -> mm_interconnect_0:jtag_uart_0_avalon_jtag_slave_waitrequest
	wire   [0:0] mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_address;          // mm_interconnect_0:jtag_uart_0_avalon_jtag_slave_address -> jtag_uart_0:av_address
	wire         mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_read;             // mm_interconnect_0:jtag_uart_0_avalon_jtag_slave_read -> jtag_uart_0:av_read_n
	wire         mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_write;            // mm_interconnect_0:jtag_uart_0_avalon_jtag_slave_write -> jtag_uart_0:av_write_n
	wire  [31:0] mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_writedata;        // mm_interconnect_0:jtag_uart_0_avalon_jtag_slave_writedata -> jtag_uart_0:av_writedata
	wire  [31:0] mm_interconnect_0_sysid_qsys_control_slave_readdata;              // sysid_qsys:readdata -> mm_interconnect_0:sysid_qsys_control_slave_readdata
	wire   [0:0] mm_interconnect_0_sysid_qsys_control_slave_address;               // mm_interconnect_0:sysid_qsys_control_slave_address -> sysid_qsys:address
	wire  [31:0] mm_interconnect_0_onchip_flash_data_readdata;                     // onchip_flash:avmm_data_readdata -> mm_interconnect_0:onchip_flash_data_readdata
	wire         mm_interconnect_0_onchip_flash_data_waitrequest;                  // onchip_flash:avmm_data_waitrequest -> mm_interconnect_0:onchip_flash_data_waitrequest
	wire  [12:0] mm_interconnect_0_onchip_flash_data_address;                      // mm_interconnect_0:onchip_flash_data_address -> onchip_flash:avmm_data_addr
	wire         mm_interconnect_0_onchip_flash_data_read;                         // mm_interconnect_0:onchip_flash_data_read -> onchip_flash:avmm_data_read
	wire         mm_interconnect_0_onchip_flash_data_readdatavalid;                // onchip_flash:avmm_data_readdatavalid -> mm_interconnect_0:onchip_flash_data_readdatavalid
	wire   [3:0] mm_interconnect_0_onchip_flash_data_burstcount;                   // mm_interconnect_0:onchip_flash_data_burstcount -> onchip_flash:avmm_data_burstcount
	wire  [31:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_readdata;            // nios2_gen2:debug_mem_slave_readdata -> mm_interconnect_0:nios2_gen2_debug_mem_slave_readdata
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_waitrequest;         // nios2_gen2:debug_mem_slave_waitrequest -> mm_interconnect_0:nios2_gen2_debug_mem_slave_waitrequest
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_debugaccess;         // mm_interconnect_0:nios2_gen2_debug_mem_slave_debugaccess -> nios2_gen2:debug_mem_slave_debugaccess
	wire   [8:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_address;             // mm_interconnect_0:nios2_gen2_debug_mem_slave_address -> nios2_gen2:debug_mem_slave_address
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_read;                // mm_interconnect_0:nios2_gen2_debug_mem_slave_read -> nios2_gen2:debug_mem_slave_read
	wire   [3:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_byteenable;          // mm_interconnect_0:nios2_gen2_debug_mem_slave_byteenable -> nios2_gen2:debug_mem_slave_byteenable
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_write;               // mm_interconnect_0:nios2_gen2_debug_mem_slave_write -> nios2_gen2:debug_mem_slave_write
	wire  [31:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_writedata;           // mm_interconnect_0:nios2_gen2_debug_mem_slave_writedata -> nios2_gen2:debug_mem_slave_writedata
	wire  [31:0] mm_interconnect_0_altpll_pll_slave_readdata;                      // altpll:readdata -> mm_interconnect_0:altpll_pll_slave_readdata
	wire   [1:0] mm_interconnect_0_altpll_pll_slave_address;                       // mm_interconnect_0:altpll_pll_slave_address -> altpll:address
	wire         mm_interconnect_0_altpll_pll_slave_read;                          // mm_interconnect_0:altpll_pll_slave_read -> altpll:read
	wire         mm_interconnect_0_altpll_pll_slave_write;                         // mm_interconnect_0:altpll_pll_slave_write -> altpll:write
	wire  [31:0] mm_interconnect_0_altpll_pll_slave_writedata;                     // mm_interconnect_0:altpll_pll_slave_writedata -> altpll:writedata
	wire         mm_interconnect_0_onchip_memory_s1_chipselect;                    // mm_interconnect_0:onchip_memory_s1_chipselect -> onchip_memory:chipselect
	wire  [31:0] mm_interconnect_0_onchip_memory_s1_readdata;                      // onchip_memory:readdata -> mm_interconnect_0:onchip_memory_s1_readdata
	wire  [11:0] mm_interconnect_0_onchip_memory_s1_address;                       // mm_interconnect_0:onchip_memory_s1_address -> onchip_memory:address
	wire   [3:0] mm_interconnect_0_onchip_memory_s1_byteenable;                    // mm_interconnect_0:onchip_memory_s1_byteenable -> onchip_memory:byteenable
	wire         mm_interconnect_0_onchip_memory_s1_write;                         // mm_interconnect_0:onchip_memory_s1_write -> onchip_memory:write
	wire  [31:0] mm_interconnect_0_onchip_memory_s1_writedata;                     // mm_interconnect_0:onchip_memory_s1_writedata -> onchip_memory:writedata
	wire         mm_interconnect_0_onchip_memory_s1_clken;                         // mm_interconnect_0:onchip_memory_s1_clken -> onchip_memory:clken
	wire         mm_interconnect_0_uart_0_s1_chipselect;                           // mm_interconnect_0:uart_0_s1_chipselect -> uart_0:chipselect
	wire  [15:0] mm_interconnect_0_uart_0_s1_readdata;                             // uart_0:readdata -> mm_interconnect_0:uart_0_s1_readdata
	wire   [2:0] mm_interconnect_0_uart_0_s1_address;                              // mm_interconnect_0:uart_0_s1_address -> uart_0:address
	wire         mm_interconnect_0_uart_0_s1_read;                                 // mm_interconnect_0:uart_0_s1_read -> uart_0:read_n
	wire         mm_interconnect_0_uart_0_s1_begintransfer;                        // mm_interconnect_0:uart_0_s1_begintransfer -> uart_0:begintransfer
	wire         mm_interconnect_0_uart_0_s1_write;                                // mm_interconnect_0:uart_0_s1_write -> uart_0:write_n
	wire  [15:0] mm_interconnect_0_uart_0_s1_writedata;                            // mm_interconnect_0:uart_0_s1_writedata -> uart_0:writedata
	wire  [15:0] mm_interconnect_0_sdram_s1_readdata;                              // sdram:avs_readdata -> mm_interconnect_0:sdram_s1_readdata
	wire         mm_interconnect_0_sdram_s1_waitrequest;                           // sdram:avs_waitrequest -> mm_interconnect_0:sdram_s1_waitrequest
	wire  [21:0] mm_interconnect_0_sdram_s1_address;                               // mm_interconnect_0:sdram_s1_address -> sdram:avs_address
	wire         mm_interconnect_0_sdram_s1_read;                                  // mm_interconnect_0:sdram_s1_read -> sdram:avs_read
	wire   [1:0] mm_interconnect_0_sdram_s1_byteenable;                            // mm_interconnect_0:sdram_s1_byteenable -> sdram:avs_byteenable
	wire         mm_interconnect_0_sdram_s1_readdatavalid;                         // sdram:avs_readdatavalid -> mm_interconnect_0:sdram_s1_readdatavalid
	wire         mm_interconnect_0_sdram_s1_write;                                 // mm_interconnect_0:sdram_s1_write -> sdram:avs_write
	wire  [15:0] mm_interconnect_0_sdram_s1_writedata;                             // mm_interconnect_0:sdram_s1_writedata -> sdram:avs_writedata
	wire         mm_interconnect_0_timer_100ms_s1_chipselect;                      // mm_interconnect_0:timer_100ms_s1_chipselect -> timer_100ms:chipselect
	wire  [15:0] mm_interconnect_0_timer_100ms_s1_readdata;                        // timer_100ms:readdata -> mm_interconnect_0:timer_100ms_s1_readdata
	wire   [2:0] mm_interconnect_0_timer_100ms_s1_address;                         // mm_interconnect_0:timer_100ms_s1_address -> timer_100ms:address
	wire         mm_interconnect_0_timer_100ms_s1_write;                           // mm_interconnect_0:timer_100ms_s1_write -> timer_100ms:write_n
	wire  [15:0] mm_interconnect_0_timer_100ms_s1_writedata;                       // mm_interconnect_0:timer_100ms_s1_writedata -> timer_100ms:writedata
	wire         mm_interconnect_0_pio_led_s1_chipselect;                          // mm_interconnect_0:pio_led_s1_chipselect -> pio_led:chipselect
	wire  [31:0] mm_interconnect_0_pio_led_s1_readdata;                            // pio_led:readdata -> mm_interconnect_0:pio_led_s1_readdata
	wire   [1:0] mm_interconnect_0_pio_led_s1_address;                             // mm_interconnect_0:pio_led_s1_address -> pio_led:address
	wire         mm_interconnect_0_pio_led_s1_write;                               // mm_interconnect_0:pio_led_s1_write -> pio_led:write_n
	wire  [31:0] mm_interconnect_0_pio_led_s1_writedata;                           // mm_interconnect_0:pio_led_s1_writedata -> pio_led:writedata
	wire  [15:0] mm_interconnect_0_flash_uas_readdata;                             // flash:uas_readdata -> mm_interconnect_0:flash_uas_readdata
	wire         mm_interconnect_0_flash_uas_waitrequest;                          // flash:uas_waitrequest -> mm_interconnect_0:flash_uas_waitrequest
	wire         mm_interconnect_0_flash_uas_debugaccess;                          // mm_interconnect_0:flash_uas_debugaccess -> flash:uas_debugaccess
	wire  [21:0] mm_interconnect_0_flash_uas_address;                              // mm_interconnect_0:flash_uas_address -> flash:uas_address
	wire         mm_interconnect_0_flash_uas_read;                                 // mm_interconnect_0:flash_uas_read -> flash:uas_read
	wire   [1:0] mm_interconnect_0_flash_uas_byteenable;                           // mm_interconnect_0:flash_uas_byteenable -> flash:uas_byteenable
	wire         mm_interconnect_0_flash_uas_readdatavalid;                        // flash:uas_readdatavalid -> mm_interconnect_0:flash_uas_readdatavalid
	wire         mm_interconnect_0_flash_uas_lock;                                 // mm_interconnect_0:flash_uas_lock -> flash:uas_lock
	wire         mm_interconnect_0_flash_uas_write;                                // mm_interconnect_0:flash_uas_write -> flash:uas_write
	wire  [15:0] mm_interconnect_0_flash_uas_writedata;                            // mm_interconnect_0:flash_uas_writedata -> flash:uas_writedata
	wire   [1:0] mm_interconnect_0_flash_uas_burstcount;                           // mm_interconnect_0:flash_uas_burstcount -> flash:uas_burstcount
	wire         irq_mapper_receiver0_irq;                                         // uart_0:irq -> irq_mapper:receiver0_irq
	wire         irq_mapper_receiver1_irq;                                         // jtag_uart_0:av_irq -> irq_mapper:receiver1_irq
	wire         irq_mapper_receiver2_irq;                                         // timer_100ms:irq -> irq_mapper:receiver2_irq
	wire  [31:0] nios2_gen2_irq_irq;                                               // irq_mapper:sender_irq -> nios2_gen2:irq
	wire         rst_controller_reset_out_reset;                                   // rst_controller:reset_out -> [altpll:reset, mm_interconnect_0:altpll_inclk_interface_reset_reset_bridge_in_reset_reset]
	wire         reset_controller_reset_out_reset;                                 // reset_controller:reset_out -> [rst_controller:reset_in0, rst_controller_001:reset_in0]
	wire         rst_controller_001_reset_out_reset;                               // rst_controller_001:reset_out -> [flash:reset_reset, irq_mapper:reset, jtag_uart_0:rst_n, mm_interconnect_0:nios2_gen2_reset_reset_bridge_in_reset_reset, nios2_gen2:reset_n, onchip_flash:reset_n, onchip_memory:reset, pio_led:reset_n, rst_translator:in_reset, sdram:rst_n, sysid_qsys:reset_n, timer_100ms:reset_n, tristate_conduit_bridge_0:reset, tristate_conduit_pin_sharer_0:reset_reset, uart_0:reset_n]
	wire         rst_controller_001_reset_out_reset_req;                           // rst_controller_001:reset_req -> [nios2_gen2:reset_req, onchip_memory:reset_req, rst_translator:reset_req_in]

	keim08core_altpll altpll (
		.clk                (clk_clk),                                      //       inclk_interface.clk
		.reset              (rst_controller_reset_out_reset),               // inclk_interface_reset.reset
		.read               (mm_interconnect_0_altpll_pll_slave_read),      //             pll_slave.read
		.write              (mm_interconnect_0_altpll_pll_slave_write),     //                      .write
		.address            (mm_interconnect_0_altpll_pll_slave_address),   //                      .address
		.readdata           (mm_interconnect_0_altpll_pll_slave_readdata),  //                      .readdata
		.writedata          (mm_interconnect_0_altpll_pll_slave_writedata), //                      .writedata
		.inclk0             (clk_clk),                                      //                inclk0.clk
		.c0                 (altpll_c0_clk),                                //                    c0.clk
		.c1                 (altpll_c1_clk),                                //                    c1.clk
		.areset             (altpll_areset_export),                         //        areset_conduit.export
		.locked             (altpll_locked_export),                         //        locked_conduit.export
		.scandone           (),                                             //           (terminated)
		.scandataout        (),                                             //           (terminated)
		.c2                 (),                                             //           (terminated)
		.c3                 (),                                             //           (terminated)
		.c4                 (),                                             //           (terminated)
		.phasedone          (),                                             //           (terminated)
		.phasecounterselect (3'b000),                                       //           (terminated)
		.phaseupdown        (1'b0),                                         //           (terminated)
		.phasestep          (1'b0),                                         //           (terminated)
		.scanclk            (1'b0),                                         //           (terminated)
		.scanclkena         (1'b0),                                         //           (terminated)
		.scandata           (1'b0),                                         //           (terminated)
		.configupdate       (1'b0)                                          //           (terminated)
	);

	keim08core_flash #(
		.TCM_ADDRESS_W                  (22),
		.TCM_DATA_W                     (16),
		.TCM_BYTEENABLE_W               (2),
		.TCM_READ_WAIT                  (100),
		.TCM_WRITE_WAIT                 (100),
		.TCM_SETUP_WAIT                 (25),
		.TCM_DATA_HOLD                  (20),
		.TCM_TURNAROUND_TIME            (2),
		.TCM_TIMING_UNITS               (0),
		.TCM_READLATENCY                (2),
		.TCM_SYMBOLS_PER_WORD           (2),
		.USE_READDATA                   (1),
		.USE_WRITEDATA                  (1),
		.USE_READ                       (1),
		.USE_WRITE                      (1),
		.USE_BYTEENABLE                 (0),
		.USE_CHIPSELECT                 (1),
		.USE_LOCK                       (0),
		.USE_ADDRESS                    (1),
		.USE_WAITREQUEST                (0),
		.USE_WRITEBYTEENABLE            (0),
		.USE_OUTPUTENABLE               (0),
		.USE_RESETREQUEST               (0),
		.USE_IRQ                        (0),
		.USE_RESET_OUTPUT               (1),
		.ACTIVE_LOW_READ                (1),
		.ACTIVE_LOW_LOCK                (0),
		.ACTIVE_LOW_WRITE               (1),
		.ACTIVE_LOW_CHIPSELECT          (1),
		.ACTIVE_LOW_BYTEENABLE          (0),
		.ACTIVE_LOW_OUTPUTENABLE        (0),
		.ACTIVE_LOW_WRITEBYTEENABLE     (0),
		.ACTIVE_LOW_WAITREQUEST         (0),
		.ACTIVE_LOW_BEGINTRANSFER       (0),
		.CHIPSELECT_THROUGH_READLATENCY (0)
	) flash (
		.clk_clk              (altpll_c0_clk),                             //   clk.clk
		.reset_reset          (rst_controller_001_reset_out_reset),        // reset.reset
		.uas_address          (mm_interconnect_0_flash_uas_address),       //   uas.address
		.uas_burstcount       (mm_interconnect_0_flash_uas_burstcount),    //      .burstcount
		.uas_read             (mm_interconnect_0_flash_uas_read),          //      .read
		.uas_write            (mm_interconnect_0_flash_uas_write),         //      .write
		.uas_waitrequest      (mm_interconnect_0_flash_uas_waitrequest),   //      .waitrequest
		.uas_readdatavalid    (mm_interconnect_0_flash_uas_readdatavalid), //      .readdatavalid
		.uas_byteenable       (mm_interconnect_0_flash_uas_byteenable),    //      .byteenable
		.uas_readdata         (mm_interconnect_0_flash_uas_readdata),      //      .readdata
		.uas_writedata        (mm_interconnect_0_flash_uas_writedata),     //      .writedata
		.uas_lock             (mm_interconnect_0_flash_uas_lock),          //      .lock
		.uas_debugaccess      (mm_interconnect_0_flash_uas_debugaccess),   //      .debugaccess
		.tcm_write_n_out      (flash_tcm_write_n_out),                     //   tcm.write_n_out
		.tcm_read_n_out       (flash_tcm_read_n_out),                      //      .read_n_out
		.tcm_chipselect_n_out (flash_tcm_chipselect_n_out),                //      .chipselect_n_out
		.tcm_reset_n_out      (flash_tcm_reset_n_out),                     //      .reset_n_out
		.tcm_request          (flash_tcm_request),                         //      .request
		.tcm_grant            (flash_tcm_grant),                           //      .grant
		.tcm_address_out      (flash_tcm_address_out),                     //      .address_out
		.tcm_data_out         (flash_tcm_data_out),                        //      .data_out
		.tcm_data_outen       (flash_tcm_data_outen),                      //      .data_outen
		.tcm_data_in          (flash_tcm_data_in)                          //      .data_in
	);

	keim08core_jtag_uart_0 jtag_uart_0 (
		.clk            (altpll_c0_clk),                                               //               clk.clk
		.rst_n          (~rst_controller_001_reset_out_reset),                         //             reset.reset_n
		.av_chipselect  (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_chipselect),  // avalon_jtag_slave.chipselect
		.av_address     (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_address),     //                  .address
		.av_read_n      (~mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_read),       //                  .read_n
		.av_readdata    (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_readdata),    //                  .readdata
		.av_write_n     (~mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_write),      //                  .write_n
		.av_writedata   (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_writedata),   //                  .writedata
		.av_waitrequest (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_waitrequest), //                  .waitrequest
		.av_irq         (irq_mapper_receiver1_irq)                                     //               irq.irq
	);

	keim08core_nios2_gen2 nios2_gen2 (
		.clk                                 (altpll_c0_clk),                                            //                       clk.clk
		.reset_n                             (~rst_controller_001_reset_out_reset),                      //                     reset.reset_n
		.reset_req                           (rst_controller_001_reset_out_reset_req),                   //                          .reset_req
		.d_address                           (nios2_gen2_data_master_address),                           //               data_master.address
		.d_byteenable                        (nios2_gen2_data_master_byteenable),                        //                          .byteenable
		.d_read                              (nios2_gen2_data_master_read),                              //                          .read
		.d_readdata                          (nios2_gen2_data_master_readdata),                          //                          .readdata
		.d_waitrequest                       (nios2_gen2_data_master_waitrequest),                       //                          .waitrequest
		.d_write                             (nios2_gen2_data_master_write),                             //                          .write
		.d_writedata                         (nios2_gen2_data_master_writedata),                         //                          .writedata
		.d_readdatavalid                     (nios2_gen2_data_master_readdatavalid),                     //                          .readdatavalid
		.debug_mem_slave_debugaccess_to_roms (nios2_gen2_data_master_debugaccess),                       //                          .debugaccess
		.i_address                           (nios2_gen2_instruction_master_address),                    //        instruction_master.address
		.i_read                              (nios2_gen2_instruction_master_read),                       //                          .read
		.i_readdata                          (nios2_gen2_instruction_master_readdata),                   //                          .readdata
		.i_waitrequest                       (nios2_gen2_instruction_master_waitrequest),                //                          .waitrequest
		.i_readdatavalid                     (nios2_gen2_instruction_master_readdatavalid),              //                          .readdatavalid
		.irq                                 (nios2_gen2_irq_irq),                                       //                       irq.irq
		.debug_reset_request                 (nios2_gen2_debug_reset_request_reset),                     //       debug_reset_request.reset
		.debug_mem_slave_address             (mm_interconnect_0_nios2_gen2_debug_mem_slave_address),     //           debug_mem_slave.address
		.debug_mem_slave_byteenable          (mm_interconnect_0_nios2_gen2_debug_mem_slave_byteenable),  //                          .byteenable
		.debug_mem_slave_debugaccess         (mm_interconnect_0_nios2_gen2_debug_mem_slave_debugaccess), //                          .debugaccess
		.debug_mem_slave_read                (mm_interconnect_0_nios2_gen2_debug_mem_slave_read),        //                          .read
		.debug_mem_slave_readdata            (mm_interconnect_0_nios2_gen2_debug_mem_slave_readdata),    //                          .readdata
		.debug_mem_slave_waitrequest         (mm_interconnect_0_nios2_gen2_debug_mem_slave_waitrequest), //                          .waitrequest
		.debug_mem_slave_write               (mm_interconnect_0_nios2_gen2_debug_mem_slave_write),       //                          .write
		.debug_mem_slave_writedata           (mm_interconnect_0_nios2_gen2_debug_mem_slave_writedata),   //                          .writedata
		.dummy_ci_port                       ()                                                          // custom_instruction_master.readra
	);

	altera_onchip_flash #(
		.INIT_FILENAME                       (""),
		.INIT_FILENAME_SIM                   (""),
		.DEVICE_FAMILY                       ("MAX 10"),
		.PART_NAME                           ("10M08SCU169I7G"),
		.DEVICE_ID                           ("08"),
		.SECTOR1_START_ADDR                  (0),
		.SECTOR1_END_ADDR                    (4095),
		.SECTOR2_START_ADDR                  (4096),
		.SECTOR2_END_ADDR                    (8191),
		.SECTOR3_START_ADDR                  (0),
		.SECTOR3_END_ADDR                    (0),
		.SECTOR4_START_ADDR                  (0),
		.SECTOR4_END_ADDR                    (0),
		.SECTOR5_START_ADDR                  (0),
		.SECTOR5_END_ADDR                    (0),
		.MIN_VALID_ADDR                      (0),
		.MAX_VALID_ADDR                      (8191),
		.MIN_UFM_VALID_ADDR                  (0),
		.MAX_UFM_VALID_ADDR                  (8191),
		.SECTOR1_MAP                         (1),
		.SECTOR2_MAP                         (2),
		.SECTOR3_MAP                         (0),
		.SECTOR4_MAP                         (0),
		.SECTOR5_MAP                         (0),
		.ADDR_RANGE1_END_ADDR                (8191),
		.ADDR_RANGE2_END_ADDR                (8191),
		.ADDR_RANGE1_OFFSET                  (512),
		.ADDR_RANGE2_OFFSET                  (0),
		.ADDR_RANGE3_OFFSET                  (0),
		.AVMM_DATA_ADDR_WIDTH                (13),
		.AVMM_DATA_DATA_WIDTH                (32),
		.AVMM_DATA_BURSTCOUNT_WIDTH          (4),
		.SECTOR_READ_PROTECTION_MODE         (31),
		.FLASH_SEQ_READ_DATA_COUNT           (2),
		.FLASH_ADDR_ALIGNMENT_BITS           (1),
		.FLASH_READ_CYCLE_MAX_INDEX          (4),
		.FLASH_RESET_CYCLE_MAX_INDEX         (20),
		.FLASH_BUSY_TIMEOUT_CYCLE_MAX_INDEX  (96),
		.FLASH_ERASE_TIMEOUT_CYCLE_MAX_INDEX (28000000),
		.FLASH_WRITE_TIMEOUT_CYCLE_MAX_INDEX (24400),
		.PARALLEL_MODE                       (1),
		.READ_AND_WRITE_MODE                 (0),
		.WRAPPING_BURST_MODE                 (0),
		.IS_DUAL_BOOT                        ("False"),
		.IS_ERAM_SKIP                        ("True"),
		.IS_COMPRESSED_IMAGE                 ("False")
	) onchip_flash (
		.clock                   (altpll_c0_clk),                                     //    clk.clk
		.reset_n                 (~rst_controller_001_reset_out_reset),               // nreset.reset_n
		.avmm_data_addr          (mm_interconnect_0_onchip_flash_data_address),       //   data.address
		.avmm_data_read          (mm_interconnect_0_onchip_flash_data_read),          //       .read
		.avmm_data_readdata      (mm_interconnect_0_onchip_flash_data_readdata),      //       .readdata
		.avmm_data_waitrequest   (mm_interconnect_0_onchip_flash_data_waitrequest),   //       .waitrequest
		.avmm_data_readdatavalid (mm_interconnect_0_onchip_flash_data_readdatavalid), //       .readdatavalid
		.avmm_data_burstcount    (mm_interconnect_0_onchip_flash_data_burstcount),    //       .burstcount
		.avmm_data_writedata     (32'b00000000000000000000000000000000),              // (terminated)
		.avmm_data_write         (1'b0),                                              // (terminated)
		.avmm_csr_addr           (1'b0),                                              // (terminated)
		.avmm_csr_read           (1'b0),                                              // (terminated)
		.avmm_csr_writedata      (32'b00000000000000000000000000000000),              // (terminated)
		.avmm_csr_write          (1'b0),                                              // (terminated)
		.avmm_csr_readdata       ()                                                   // (terminated)
	);

	keim08core_onchip_memory onchip_memory (
		.clk        (altpll_c0_clk),                                 //   clk1.clk
		.address    (mm_interconnect_0_onchip_memory_s1_address),    //     s1.address
		.clken      (mm_interconnect_0_onchip_memory_s1_clken),      //       .clken
		.chipselect (mm_interconnect_0_onchip_memory_s1_chipselect), //       .chipselect
		.write      (mm_interconnect_0_onchip_memory_s1_write),      //       .write
		.readdata   (mm_interconnect_0_onchip_memory_s1_readdata),   //       .readdata
		.writedata  (mm_interconnect_0_onchip_memory_s1_writedata),  //       .writedata
		.byteenable (mm_interconnect_0_onchip_memory_s1_byteenable), //       .byteenable
		.reset      (rst_controller_001_reset_out_reset),            // reset1.reset
		.reset_req  (rst_controller_001_reset_out_reset_req),        //       .reset_req
		.freeze     (1'b0)                                           // (terminated)
	);

	keim08core_pio_led pio_led (
		.clk        (altpll_c0_clk),                           //                 clk.clk
		.reset_n    (~rst_controller_001_reset_out_reset),     //               reset.reset_n
		.address    (mm_interconnect_0_pio_led_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_pio_led_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_pio_led_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_pio_led_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_pio_led_s1_readdata),   //                    .readdata
		.out_port   (pio_led_external_connection_export)       // external_connection.export
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (2),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) reset_controller (
		.reset_in0      (~reset_reset_n),                       // reset_in0.reset
		.reset_in1      (nios2_gen2_debug_reset_request_reset), // reset_in1.reset
		.clk            (altpll_c0_clk),                        //       clk.clk
		.reset_out      (reset_controller_reset_out_reset),     // reset_out.reset
		.reset_req      (),                                     // (terminated)
		.reset_req_in0  (1'b0),                                 // (terminated)
		.reset_req_in1  (1'b0),                                 // (terminated)
		.reset_in2      (1'b0),                                 // (terminated)
		.reset_req_in2  (1'b0),                                 // (terminated)
		.reset_in3      (1'b0),                                 // (terminated)
		.reset_req_in3  (1'b0),                                 // (terminated)
		.reset_in4      (1'b0),                                 // (terminated)
		.reset_req_in4  (1'b0),                                 // (terminated)
		.reset_in5      (1'b0),                                 // (terminated)
		.reset_req_in5  (1'b0),                                 // (terminated)
		.reset_in6      (1'b0),                                 // (terminated)
		.reset_req_in6  (1'b0),                                 // (terminated)
		.reset_in7      (1'b0),                                 // (terminated)
		.reset_req_in7  (1'b0),                                 // (terminated)
		.reset_in8      (1'b0),                                 // (terminated)
		.reset_req_in8  (1'b0),                                 // (terminated)
		.reset_in9      (1'b0),                                 // (terminated)
		.reset_req_in9  (1'b0),                                 // (terminated)
		.reset_in10     (1'b0),                                 // (terminated)
		.reset_req_in10 (1'b0),                                 // (terminated)
		.reset_in11     (1'b0),                                 // (terminated)
		.reset_req_in11 (1'b0),                                 // (terminated)
		.reset_in12     (1'b0),                                 // (terminated)
		.reset_req_in12 (1'b0),                                 // (terminated)
		.reset_in13     (1'b0),                                 // (terminated)
		.reset_req_in13 (1'b0),                                 // (terminated)
		.reset_in14     (1'b0),                                 // (terminated)
		.reset_req_in14 (1'b0),                                 // (terminated)
		.reset_in15     (1'b0),                                 // (terminated)
		.reset_req_in15 (1'b0)                                  // (terminated)
	);

	altera_sdram_tri_controller #(
		.CAS_LATENCY      (3),
		.SDRAM_COL_WIDTH  (8),
		.SDRAM_DATA_WIDTH (16),
		.INIT_REFRESH     (2),
		.NUM_CHIPSELECTS  (1),
		.TRISTATE_EN      (1),
		.SDRAM_ROW_WIDTH  (12),
		.T_RCD            (1),
		.T_RFC            (5),
		.T_RP             (1),
		.T_WR             (1),
		.SDRAM_BANK_WIDTH (2),
		.POWERUP_DELAY    (0),
		.REFRESH_PERIOD   (1250),
		.CNTRL_ADDR_WIDTH (22),
		.MAX_REC_TIME     (1)
	) sdram (
		.clk               (altpll_c0_clk),                            // clock_sink.clk
		.rst_n             (~rst_controller_001_reset_out_reset),      // reset_sink.reset_n
		.avs_address       (mm_interconnect_0_sdram_s1_address),       //         s1.address
		.avs_byteenable    (mm_interconnect_0_sdram_s1_byteenable),    //           .byteenable
		.avs_writedata     (mm_interconnect_0_sdram_s1_writedata),     //           .writedata
		.avs_read          (mm_interconnect_0_sdram_s1_read),          //           .read
		.avs_write         (mm_interconnect_0_sdram_s1_write),         //           .write
		.avs_readdata      (mm_interconnect_0_sdram_s1_readdata),      //           .readdata
		.avs_readdatavalid (mm_interconnect_0_sdram_s1_readdatavalid), //           .readdatavalid
		.avs_waitrequest   (mm_interconnect_0_sdram_s1_waitrequest),   //           .waitrequest
		.tcm_grant         (sdram_tcm_grant),                          //        tcm.grant
		.tcm_request       (sdram_tcm_request),                        //           .request
		.sdram_dq_out      (sdram_tcm_dq_out),                         //           .dq_out
		.sdram_dq_in       (sdram_tcm_dq_in),                          //           .dq_in
		.sdram_dq_oe       (sdram_tcm_dq_outen),                       //           .dq_outen
		.sdram_addr        (sdram_tcm_addr_out),                       //           .addr_out
		.sdram_ba          (sdram_tcm_ba_out),                         //           .ba_out
		.sdram_cas_n       (sdram_tcm_cas_out),                        //           .cas_out
		.sdram_cke         (sdram_tcm_cke_out),                        //           .cke_out
		.sdram_cs_n        (sdram_tcm_cs_out),                         //           .cs_out
		.sdram_dqm         (sdram_tcm_dqm_out),                        //           .dqm_out
		.sdram_ras_n       (sdram_tcm_ras_out),                        //           .ras_out
		.sdram_we_n        (sdram_tcm_we_out),                         //           .we_out
		.sdram_dq          ()                                          // (terminated)
	);

	keim08core_sysid_qsys sysid_qsys (
		.clock    (altpll_c0_clk),                                       //           clk.clk
		.reset_n  (~rst_controller_001_reset_out_reset),                 //         reset.reset_n
		.readdata (mm_interconnect_0_sysid_qsys_control_slave_readdata), // control_slave.readdata
		.address  (mm_interconnect_0_sysid_qsys_control_slave_address)   //              .address
	);

	keim08core_timer_100ms timer_100ms (
		.clk        (altpll_c0_clk),                               //   clk.clk
		.reset_n    (~rst_controller_001_reset_out_reset),         // reset.reset_n
		.address    (mm_interconnect_0_timer_100ms_s1_address),    //    s1.address
		.writedata  (mm_interconnect_0_timer_100ms_s1_writedata),  //      .writedata
		.readdata   (mm_interconnect_0_timer_100ms_s1_readdata),   //      .readdata
		.chipselect (mm_interconnect_0_timer_100ms_s1_chipselect), //      .chipselect
		.write_n    (~mm_interconnect_0_timer_100ms_s1_write),     //      .write_n
		.irq        (irq_mapper_receiver2_irq)                     //   irq.irq
	);

	keim08core_tristate_conduit_bridge_0 tristate_conduit_bridge_0 (
		.clk                            (altpll_c0_clk),                                                    //   clk.clk
		.reset                          (rst_controller_001_reset_out_reset),                               // reset.reset
		.request                        (tristate_conduit_pin_sharer_0_tcm_request),                        //   tcs.request
		.grant                          (tristate_conduit_pin_sharer_0_tcm_grant),                          //      .grant
		.tcs_flash_tcm_reset_n_out      (tristate_conduit_pin_sharer_0_tcm_flash_tcm_reset_n_out_out),      //      .flash_tcm_reset_n_out_out
		.tcs_sdram_sdram_cke            (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cke_out),            //      .sdram_sdram_cke_out
		.tcs_sdram_sdram_cas_n          (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cas_n_out),          //      .sdram_sdram_cas_n_out
		.tcs_dq                         (tristate_conduit_pin_sharer_0_tcm_dq_out),                         //      .dq_out
		.tcs_dq_outen                   (tristate_conduit_pin_sharer_0_tcm_dq_outen),                       //      .dq_outen
		.tcs_dq_in                      (tristate_conduit_pin_sharer_0_tcm_dq_in),                          //      .dq_in
		.tcs_sdram_sdram_we_n           (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_we_n_out),           //      .sdram_sdram_we_n_out
		.tcs_sdram_sdram_cs_n           (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cs_n_out),           //      .sdram_sdram_cs_n_out
		.tcs_flash_tcm_chipselect_n_out (tristate_conduit_pin_sharer_0_tcm_flash_tcm_chipselect_n_out_out), //      .flash_tcm_chipselect_n_out_out
		.tcs_addr                       (tristate_conduit_pin_sharer_0_tcm_addr_out),                       //      .addr_out
		.tcs_sdram_sdram_ba             (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_ba_out),             //      .sdram_sdram_ba_out
		.tcs_sdram_sdram_dqm            (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_dqm_out),            //      .sdram_sdram_dqm_out
		.tcs_sdram_sdram_ras_n          (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_ras_n_out),          //      .sdram_sdram_ras_n_out
		.tcs_flash_tcm_write_n_out      (tristate_conduit_pin_sharer_0_tcm_flash_tcm_write_n_out_out),      //      .flash_tcm_write_n_out_out
		.tcs_flash_tcm_read_n_out       (tristate_conduit_pin_sharer_0_tcm_flash_tcm_read_n_out_out),       //      .flash_tcm_read_n_out_out
		.flash_tcm_reset_n_out          (emif_flash_tcm_reset_n_out),                                       //   out.flash_tcm_reset_n_out
		.sdram_sdram_cke                (emif_sdram_sdram_cke),                                             //      .sdram_sdram_cke
		.sdram_sdram_cas_n              (emif_sdram_sdram_cas_n),                                           //      .sdram_sdram_cas_n
		.dq                             (emif_dq),                                                          //      .dq
		.sdram_sdram_we_n               (emif_sdram_sdram_we_n),                                            //      .sdram_sdram_we_n
		.sdram_sdram_cs_n               (emif_sdram_sdram_cs_n),                                            //      .sdram_sdram_cs_n
		.flash_tcm_chipselect_n_out     (emif_flash_tcm_chipselect_n_out),                                  //      .flash_tcm_chipselect_n_out
		.addr                           (emif_addr),                                                        //      .addr
		.sdram_sdram_ba                 (emif_sdram_sdram_ba),                                              //      .sdram_sdram_ba
		.sdram_sdram_dqm                (emif_sdram_sdram_dqm),                                             //      .sdram_sdram_dqm
		.sdram_sdram_ras_n              (emif_sdram_sdram_ras_n),                                           //      .sdram_sdram_ras_n
		.flash_tcm_write_n_out          (emif_flash_tcm_write_n_out),                                       //      .flash_tcm_write_n_out
		.flash_tcm_read_n_out           (emif_flash_tcm_read_n_out)                                         //      .flash_tcm_read_n_out
	);

	keim08core_tristate_conduit_pin_sharer_0 tristate_conduit_pin_sharer_0 (
		.clk_clk                    (altpll_c0_clk),                                                    //   clk.clk
		.reset_reset                (rst_controller_001_reset_out_reset),                               // reset.reset
		.request                    (tristate_conduit_pin_sharer_0_tcm_request),                        //   tcm.request
		.grant                      (tristate_conduit_pin_sharer_0_tcm_grant),                          //      .grant
		.flash_tcm_read_n_out       (tristate_conduit_pin_sharer_0_tcm_flash_tcm_read_n_out_out),       //      .flash_tcm_read_n_out_out
		.flash_tcm_reset_n_out      (tristate_conduit_pin_sharer_0_tcm_flash_tcm_reset_n_out_out),      //      .flash_tcm_reset_n_out_out
		.flash_tcm_write_n_out      (tristate_conduit_pin_sharer_0_tcm_flash_tcm_write_n_out_out),      //      .flash_tcm_write_n_out_out
		.flash_tcm_chipselect_n_out (tristate_conduit_pin_sharer_0_tcm_flash_tcm_chipselect_n_out_out), //      .flash_tcm_chipselect_n_out_out
		.sdram_sdram_ras_n          (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_ras_n_out),          //      .sdram_sdram_ras_n_out
		.sdram_sdram_we_n           (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_we_n_out),           //      .sdram_sdram_we_n_out
		.sdram_sdram_cs_n           (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cs_n_out),           //      .sdram_sdram_cs_n_out
		.sdram_sdram_ba             (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_ba_out),             //      .sdram_sdram_ba_out
		.sdram_sdram_dqm            (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_dqm_out),            //      .sdram_sdram_dqm_out
		.sdram_sdram_cas_n          (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cas_n_out),          //      .sdram_sdram_cas_n_out
		.sdram_sdram_cke            (tristate_conduit_pin_sharer_0_tcm_sdram_sdram_cke_out),            //      .sdram_sdram_cke_out
		.dq                         (tristate_conduit_pin_sharer_0_tcm_dq_out),                         //      .dq_out
		.dq_in                      (tristate_conduit_pin_sharer_0_tcm_dq_in),                          //      .dq_in
		.dq_outen                   (tristate_conduit_pin_sharer_0_tcm_dq_outen),                       //      .dq_outen
		.addr                       (tristate_conduit_pin_sharer_0_tcm_addr_out),                       //      .addr_out
		.tcs0_request               (sdram_tcm_request),                                                //  tcs0.request
		.tcs0_grant                 (sdram_tcm_grant),                                                  //      .grant
		.tcs0_ras_out               (sdram_tcm_ras_out),                                                //      .ras_out
		.tcs0_we_out                (sdram_tcm_we_out),                                                 //      .we_out
		.tcs0_dq_out                (sdram_tcm_dq_out),                                                 //      .dq_out
		.tcs0_dq_in                 (sdram_tcm_dq_in),                                                  //      .dq_in
		.tcs0_dq_outen              (sdram_tcm_dq_outen),                                               //      .dq_outen
		.tcs0_cs_out                (sdram_tcm_cs_out),                                                 //      .cs_out
		.tcs0_addr_out              (sdram_tcm_addr_out),                                               //      .addr_out
		.tcs0_ba_out                (sdram_tcm_ba_out),                                                 //      .ba_out
		.tcs0_dqm_out               (sdram_tcm_dqm_out),                                                //      .dqm_out
		.tcs0_cas_out               (sdram_tcm_cas_out),                                                //      .cas_out
		.tcs0_cke_out               (sdram_tcm_cke_out),                                                //      .cke_out
		.tcs1_request               (flash_tcm_request),                                                //  tcs1.request
		.tcs1_grant                 (flash_tcm_grant),                                                  //      .grant
		.tcs1_address_out           (flash_tcm_address_out),                                            //      .address_out
		.tcs1_read_n_out            (flash_tcm_read_n_out),                                             //      .read_n_out
		.tcs1_reset_n_out           (flash_tcm_reset_n_out),                                            //      .reset_n_out
		.tcs1_write_n_out           (flash_tcm_write_n_out),                                            //      .write_n_out
		.tcs1_data_out              (flash_tcm_data_out),                                               //      .data_out
		.tcs1_data_in               (flash_tcm_data_in),                                                //      .data_in
		.tcs1_data_outen            (flash_tcm_data_outen),                                             //      .data_outen
		.tcs1_chipselect_n_out      (flash_tcm_chipselect_n_out)                                        //      .chipselect_n_out
	);

	keim08core_uart_0 uart_0 (
		.clk           (altpll_c0_clk),                             //                 clk.clk
		.reset_n       (~rst_controller_001_reset_out_reset),       //               reset.reset_n
		.address       (mm_interconnect_0_uart_0_s1_address),       //                  s1.address
		.begintransfer (mm_interconnect_0_uart_0_s1_begintransfer), //                    .begintransfer
		.chipselect    (mm_interconnect_0_uart_0_s1_chipselect),    //                    .chipselect
		.read_n        (~mm_interconnect_0_uart_0_s1_read),         //                    .read_n
		.write_n       (~mm_interconnect_0_uart_0_s1_write),        //                    .write_n
		.writedata     (mm_interconnect_0_uart_0_s1_writedata),     //                    .writedata
		.readdata      (mm_interconnect_0_uart_0_s1_readdata),      //                    .readdata
		.rxd           (uart_0_rxd),                                // external_connection.export
		.txd           (uart_0_txd),                                //                    .export
		.irq           (irq_mapper_receiver0_irq)                   //                 irq.irq
	);

	keim08core_mm_interconnect_0 mm_interconnect_0 (
		.altpll_c0_clk                                            (altpll_c0_clk),                                               //                                          altpll_c0.clk
		.clk_0_clk_clk                                            (clk_clk),                                                     //                                          clk_0_clk.clk
		.altpll_inclk_interface_reset_reset_bridge_in_reset_reset (rst_controller_reset_out_reset),                              // altpll_inclk_interface_reset_reset_bridge_in_reset.reset
		.nios2_gen2_reset_reset_bridge_in_reset_reset             (rst_controller_001_reset_out_reset),                          //             nios2_gen2_reset_reset_bridge_in_reset.reset
		.nios2_gen2_data_master_address                           (nios2_gen2_data_master_address),                              //                             nios2_gen2_data_master.address
		.nios2_gen2_data_master_waitrequest                       (nios2_gen2_data_master_waitrequest),                          //                                                   .waitrequest
		.nios2_gen2_data_master_byteenable                        (nios2_gen2_data_master_byteenable),                           //                                                   .byteenable
		.nios2_gen2_data_master_read                              (nios2_gen2_data_master_read),                                 //                                                   .read
		.nios2_gen2_data_master_readdata                          (nios2_gen2_data_master_readdata),                             //                                                   .readdata
		.nios2_gen2_data_master_readdatavalid                     (nios2_gen2_data_master_readdatavalid),                        //                                                   .readdatavalid
		.nios2_gen2_data_master_write                             (nios2_gen2_data_master_write),                                //                                                   .write
		.nios2_gen2_data_master_writedata                         (nios2_gen2_data_master_writedata),                            //                                                   .writedata
		.nios2_gen2_data_master_debugaccess                       (nios2_gen2_data_master_debugaccess),                          //                                                   .debugaccess
		.nios2_gen2_instruction_master_address                    (nios2_gen2_instruction_master_address),                       //                      nios2_gen2_instruction_master.address
		.nios2_gen2_instruction_master_waitrequest                (nios2_gen2_instruction_master_waitrequest),                   //                                                   .waitrequest
		.nios2_gen2_instruction_master_read                       (nios2_gen2_instruction_master_read),                          //                                                   .read
		.nios2_gen2_instruction_master_readdata                   (nios2_gen2_instruction_master_readdata),                      //                                                   .readdata
		.nios2_gen2_instruction_master_readdatavalid              (nios2_gen2_instruction_master_readdatavalid),                 //                                                   .readdatavalid
		.altpll_pll_slave_address                                 (mm_interconnect_0_altpll_pll_slave_address),                  //                                   altpll_pll_slave.address
		.altpll_pll_slave_write                                   (mm_interconnect_0_altpll_pll_slave_write),                    //                                                   .write
		.altpll_pll_slave_read                                    (mm_interconnect_0_altpll_pll_slave_read),                     //                                                   .read
		.altpll_pll_slave_readdata                                (mm_interconnect_0_altpll_pll_slave_readdata),                 //                                                   .readdata
		.altpll_pll_slave_writedata                               (mm_interconnect_0_altpll_pll_slave_writedata),                //                                                   .writedata
		.flash_uas_address                                        (mm_interconnect_0_flash_uas_address),                         //                                          flash_uas.address
		.flash_uas_write                                          (mm_interconnect_0_flash_uas_write),                           //                                                   .write
		.flash_uas_read                                           (mm_interconnect_0_flash_uas_read),                            //                                                   .read
		.flash_uas_readdata                                       (mm_interconnect_0_flash_uas_readdata),                        //                                                   .readdata
		.flash_uas_writedata                                      (mm_interconnect_0_flash_uas_writedata),                       //                                                   .writedata
		.flash_uas_burstcount                                     (mm_interconnect_0_flash_uas_burstcount),                      //                                                   .burstcount
		.flash_uas_byteenable                                     (mm_interconnect_0_flash_uas_byteenable),                      //                                                   .byteenable
		.flash_uas_readdatavalid                                  (mm_interconnect_0_flash_uas_readdatavalid),                   //                                                   .readdatavalid
		.flash_uas_waitrequest                                    (mm_interconnect_0_flash_uas_waitrequest),                     //                                                   .waitrequest
		.flash_uas_lock                                           (mm_interconnect_0_flash_uas_lock),                            //                                                   .lock
		.flash_uas_debugaccess                                    (mm_interconnect_0_flash_uas_debugaccess),                     //                                                   .debugaccess
		.jtag_uart_0_avalon_jtag_slave_address                    (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_address),     //                      jtag_uart_0_avalon_jtag_slave.address
		.jtag_uart_0_avalon_jtag_slave_write                      (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_write),       //                                                   .write
		.jtag_uart_0_avalon_jtag_slave_read                       (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_read),        //                                                   .read
		.jtag_uart_0_avalon_jtag_slave_readdata                   (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_readdata),    //                                                   .readdata
		.jtag_uart_0_avalon_jtag_slave_writedata                  (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_writedata),   //                                                   .writedata
		.jtag_uart_0_avalon_jtag_slave_waitrequest                (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_waitrequest), //                                                   .waitrequest
		.jtag_uart_0_avalon_jtag_slave_chipselect                 (mm_interconnect_0_jtag_uart_0_avalon_jtag_slave_chipselect),  //                                                   .chipselect
		.nios2_gen2_debug_mem_slave_address                       (mm_interconnect_0_nios2_gen2_debug_mem_slave_address),        //                         nios2_gen2_debug_mem_slave.address
		.nios2_gen2_debug_mem_slave_write                         (mm_interconnect_0_nios2_gen2_debug_mem_slave_write),          //                                                   .write
		.nios2_gen2_debug_mem_slave_read                          (mm_interconnect_0_nios2_gen2_debug_mem_slave_read),           //                                                   .read
		.nios2_gen2_debug_mem_slave_readdata                      (mm_interconnect_0_nios2_gen2_debug_mem_slave_readdata),       //                                                   .readdata
		.nios2_gen2_debug_mem_slave_writedata                     (mm_interconnect_0_nios2_gen2_debug_mem_slave_writedata),      //                                                   .writedata
		.nios2_gen2_debug_mem_slave_byteenable                    (mm_interconnect_0_nios2_gen2_debug_mem_slave_byteenable),     //                                                   .byteenable
		.nios2_gen2_debug_mem_slave_waitrequest                   (mm_interconnect_0_nios2_gen2_debug_mem_slave_waitrequest),    //                                                   .waitrequest
		.nios2_gen2_debug_mem_slave_debugaccess                   (mm_interconnect_0_nios2_gen2_debug_mem_slave_debugaccess),    //                                                   .debugaccess
		.onchip_flash_data_address                                (mm_interconnect_0_onchip_flash_data_address),                 //                                  onchip_flash_data.address
		.onchip_flash_data_read                                   (mm_interconnect_0_onchip_flash_data_read),                    //                                                   .read
		.onchip_flash_data_readdata                               (mm_interconnect_0_onchip_flash_data_readdata),                //                                                   .readdata
		.onchip_flash_data_burstcount                             (mm_interconnect_0_onchip_flash_data_burstcount),              //                                                   .burstcount
		.onchip_flash_data_readdatavalid                          (mm_interconnect_0_onchip_flash_data_readdatavalid),           //                                                   .readdatavalid
		.onchip_flash_data_waitrequest                            (mm_interconnect_0_onchip_flash_data_waitrequest),             //                                                   .waitrequest
		.onchip_memory_s1_address                                 (mm_interconnect_0_onchip_memory_s1_address),                  //                                   onchip_memory_s1.address
		.onchip_memory_s1_write                                   (mm_interconnect_0_onchip_memory_s1_write),                    //                                                   .write
		.onchip_memory_s1_readdata                                (mm_interconnect_0_onchip_memory_s1_readdata),                 //                                                   .readdata
		.onchip_memory_s1_writedata                               (mm_interconnect_0_onchip_memory_s1_writedata),                //                                                   .writedata
		.onchip_memory_s1_byteenable                              (mm_interconnect_0_onchip_memory_s1_byteenable),               //                                                   .byteenable
		.onchip_memory_s1_chipselect                              (mm_interconnect_0_onchip_memory_s1_chipselect),               //                                                   .chipselect
		.onchip_memory_s1_clken                                   (mm_interconnect_0_onchip_memory_s1_clken),                    //                                                   .clken
		.pio_led_s1_address                                       (mm_interconnect_0_pio_led_s1_address),                        //                                         pio_led_s1.address
		.pio_led_s1_write                                         (mm_interconnect_0_pio_led_s1_write),                          //                                                   .write
		.pio_led_s1_readdata                                      (mm_interconnect_0_pio_led_s1_readdata),                       //                                                   .readdata
		.pio_led_s1_writedata                                     (mm_interconnect_0_pio_led_s1_writedata),                      //                                                   .writedata
		.pio_led_s1_chipselect                                    (mm_interconnect_0_pio_led_s1_chipselect),                     //                                                   .chipselect
		.sdram_s1_address                                         (mm_interconnect_0_sdram_s1_address),                          //                                           sdram_s1.address
		.sdram_s1_write                                           (mm_interconnect_0_sdram_s1_write),                            //                                                   .write
		.sdram_s1_read                                            (mm_interconnect_0_sdram_s1_read),                             //                                                   .read
		.sdram_s1_readdata                                        (mm_interconnect_0_sdram_s1_readdata),                         //                                                   .readdata
		.sdram_s1_writedata                                       (mm_interconnect_0_sdram_s1_writedata),                        //                                                   .writedata
		.sdram_s1_byteenable                                      (mm_interconnect_0_sdram_s1_byteenable),                       //                                                   .byteenable
		.sdram_s1_readdatavalid                                   (mm_interconnect_0_sdram_s1_readdatavalid),                    //                                                   .readdatavalid
		.sdram_s1_waitrequest                                     (mm_interconnect_0_sdram_s1_waitrequest),                      //                                                   .waitrequest
		.sysid_qsys_control_slave_address                         (mm_interconnect_0_sysid_qsys_control_slave_address),          //                           sysid_qsys_control_slave.address
		.sysid_qsys_control_slave_readdata                        (mm_interconnect_0_sysid_qsys_control_slave_readdata),         //                                                   .readdata
		.timer_100ms_s1_address                                   (mm_interconnect_0_timer_100ms_s1_address),                    //                                     timer_100ms_s1.address
		.timer_100ms_s1_write                                     (mm_interconnect_0_timer_100ms_s1_write),                      //                                                   .write
		.timer_100ms_s1_readdata                                  (mm_interconnect_0_timer_100ms_s1_readdata),                   //                                                   .readdata
		.timer_100ms_s1_writedata                                 (mm_interconnect_0_timer_100ms_s1_writedata),                  //                                                   .writedata
		.timer_100ms_s1_chipselect                                (mm_interconnect_0_timer_100ms_s1_chipselect),                 //                                                   .chipselect
		.uart_0_s1_address                                        (mm_interconnect_0_uart_0_s1_address),                         //                                          uart_0_s1.address
		.uart_0_s1_write                                          (mm_interconnect_0_uart_0_s1_write),                           //                                                   .write
		.uart_0_s1_read                                           (mm_interconnect_0_uart_0_s1_read),                            //                                                   .read
		.uart_0_s1_readdata                                       (mm_interconnect_0_uart_0_s1_readdata),                        //                                                   .readdata
		.uart_0_s1_writedata                                      (mm_interconnect_0_uart_0_s1_writedata),                       //                                                   .writedata
		.uart_0_s1_begintransfer                                  (mm_interconnect_0_uart_0_s1_begintransfer),                   //                                                   .begintransfer
		.uart_0_s1_chipselect                                     (mm_interconnect_0_uart_0_s1_chipselect)                       //                                                   .chipselect
	);

	keim08core_irq_mapper irq_mapper (
		.clk           (altpll_c0_clk),                      //       clk.clk
		.reset         (rst_controller_001_reset_out_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),           // receiver0.irq
		.receiver1_irq (irq_mapper_receiver1_irq),           // receiver1.irq
		.receiver2_irq (irq_mapper_receiver2_irq),           // receiver2.irq
		.sender_irq    (nios2_gen2_irq_irq)                  //    sender.irq
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (reset_controller_reset_out_reset), // reset_in0.reset
		.clk            (clk_clk),                          //       clk.clk
		.reset_out      (rst_controller_reset_out_reset),   // reset_out.reset
		.reset_req      (),                                 // (terminated)
		.reset_req_in0  (1'b0),                             // (terminated)
		.reset_in1      (1'b0),                             // (terminated)
		.reset_req_in1  (1'b0),                             // (terminated)
		.reset_in2      (1'b0),                             // (terminated)
		.reset_req_in2  (1'b0),                             // (terminated)
		.reset_in3      (1'b0),                             // (terminated)
		.reset_req_in3  (1'b0),                             // (terminated)
		.reset_in4      (1'b0),                             // (terminated)
		.reset_req_in4  (1'b0),                             // (terminated)
		.reset_in5      (1'b0),                             // (terminated)
		.reset_req_in5  (1'b0),                             // (terminated)
		.reset_in6      (1'b0),                             // (terminated)
		.reset_req_in6  (1'b0),                             // (terminated)
		.reset_in7      (1'b0),                             // (terminated)
		.reset_req_in7  (1'b0),                             // (terminated)
		.reset_in8      (1'b0),                             // (terminated)
		.reset_req_in8  (1'b0),                             // (terminated)
		.reset_in9      (1'b0),                             // (terminated)
		.reset_req_in9  (1'b0),                             // (terminated)
		.reset_in10     (1'b0),                             // (terminated)
		.reset_req_in10 (1'b0),                             // (terminated)
		.reset_in11     (1'b0),                             // (terminated)
		.reset_req_in11 (1'b0),                             // (terminated)
		.reset_in12     (1'b0),                             // (terminated)
		.reset_req_in12 (1'b0),                             // (terminated)
		.reset_in13     (1'b0),                             // (terminated)
		.reset_req_in13 (1'b0),                             // (terminated)
		.reset_in14     (1'b0),                             // (terminated)
		.reset_req_in14 (1'b0),                             // (terminated)
		.reset_in15     (1'b0),                             // (terminated)
		.reset_req_in15 (1'b0)                              // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_001 (
		.reset_in0      (reset_controller_reset_out_reset),       // reset_in0.reset
		.clk            (altpll_c0_clk),                          //       clk.clk
		.reset_out      (rst_controller_001_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_001_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                                   // (terminated)
		.reset_in1      (1'b0),                                   // (terminated)
		.reset_req_in1  (1'b0),                                   // (terminated)
		.reset_in2      (1'b0),                                   // (terminated)
		.reset_req_in2  (1'b0),                                   // (terminated)
		.reset_in3      (1'b0),                                   // (terminated)
		.reset_req_in3  (1'b0),                                   // (terminated)
		.reset_in4      (1'b0),                                   // (terminated)
		.reset_req_in4  (1'b0),                                   // (terminated)
		.reset_in5      (1'b0),                                   // (terminated)
		.reset_req_in5  (1'b0),                                   // (terminated)
		.reset_in6      (1'b0),                                   // (terminated)
		.reset_req_in6  (1'b0),                                   // (terminated)
		.reset_in7      (1'b0),                                   // (terminated)
		.reset_req_in7  (1'b0),                                   // (terminated)
		.reset_in8      (1'b0),                                   // (terminated)
		.reset_req_in8  (1'b0),                                   // (terminated)
		.reset_in9      (1'b0),                                   // (terminated)
		.reset_req_in9  (1'b0),                                   // (terminated)
		.reset_in10     (1'b0),                                   // (terminated)
		.reset_req_in10 (1'b0),                                   // (terminated)
		.reset_in11     (1'b0),                                   // (terminated)
		.reset_req_in11 (1'b0),                                   // (terminated)
		.reset_in12     (1'b0),                                   // (terminated)
		.reset_req_in12 (1'b0),                                   // (terminated)
		.reset_in13     (1'b0),                                   // (terminated)
		.reset_req_in13 (1'b0),                                   // (terminated)
		.reset_in14     (1'b0),                                   // (terminated)
		.reset_req_in14 (1'b0),                                   // (terminated)
		.reset_in15     (1'b0),                                   // (terminated)
		.reset_req_in15 (1'b0)                                    // (terminated)
	);

endmodule
